<template>
  <div class="disciplina">
    <div
      class="disciplina_status"
      :style="`background: ${getStatus(code).color}`"
      @click="changeState()">
      <fa v-if="getStatus(code).status !== 'nulo'" :icon="getStatus(code).symbol"/>
    </div>

    <div
         v-if="getStatus(code).status !== 'bloqueada'"
         class="disciplina_counter disciplina_under_button"
         @click="increment()"
         @contextmenu="decrement($event)">
      {{counter}}
    </div>

    <router-link to="/estrutura/"
      class="disciplina_info disciplina_under_button"
      v-show="isAuthenticated"
      @click.native="$store.commit('setActiveSubject', {code})"
      tag="div">
        &#8505;
    </router-link>

    <div
      class="disciplina_code"
      :style="`color: ${getStatus(code).color}`">
      {{code}}
    </div>
  </div>
</template>

<script>
import {mapGetters} from 'vuex';

export default {

  props: ["code", "creditos"],

  data() {
    return {
      counter: 1,
    }
  },

  methods:{
    increment() {
      if (!this.isOnCourse || this.isBlocked(this.code))
        return;

      this.counter++;

      this.$store.dispatch('addToPlanning', {
        code: this.code,
        counter: this.counter
      })
    },

    decrement(event) {
      if (!this.isOnCourse || this.isBlocked(this.code))
        return;

      event.preventDefault();
      if (this.counter > 1) this.counter--;

      this.$store.dispatch('addToPlanning', {
        code: this.code,
        counter: this.counter
      })
    },

    async changeState() {
      if (!this.isOnCourse || this.isBlocked(this.code))
        return;

      this.$store.dispatch('setSubjectStatus', { code: this.code});

      const credits = +this.creditos;

      const type = await this.$axios.$post(`rpc/tipo_disciplina`, {
        cdg_disciplina: this.code
      });

      let payload = { credits, code: this.code, type }

      if (this.getStatus(this.code).status === 'cursada') {
        payload.name = 'approved';
        this.$store.commit('addCredits', payload);
      }

      else if (this.getStatus(this.code).status === 'planejada') {
        payload.name = 'planned';
        this.$store.commit('addCredits', payload);

        payload.name = 'approved';
        this.$store.commit('removeCredits', payload);

        this.$store.dispatch('addToPlanning', {
          code: this.code,
          counter: this.counter
        })
      }

      else {
        payload.name = 'planned';
        this.$store.commit('removeCredits', payload);
      }
    },

    determineStyle() {
      const payload = { code: this.code, index: 0 };

      let isInsidePlan
      if (this.isOnPlan) {
        isInsidePlan = this.getActivePlan.some(subject => {
          return subject.codigo_disciplina === this.code
        })
      }

      console.log(this.code)
      console.log(this.isBlocked(this.code))

      if(this.isBlocked(this.code))
        payload['index'] = 3;

      else if ((this.isOnPlan && isInsidePlan) ||
          (this.isPlanned(this.code) && this.isOnCourse))
        payload['index'] = 2;

      else if(this.isApproved(this.code))
        payload['index'] = 1;

      this.$store.commit('setStatus', payload);
    }
  },

  watch: {
    getView: function() {
      this.determineStyle()
    },
    getActivePlan: function() {
      this.determineStyle()
    },
    getApprovedSubjects: function () {
      this.determineStyle()
    }
  },

  beforeMount() {
    this.determineStyle();
  },

  computed: {
    ...mapGetters([
      'isAuthenticated',
      'getView',
      'isOnCourse',
      'getStatus',
      'isApproved',
      'isPlanned',
      'isOnPlan',
      'getActivePlan',
      'isBlocked',
      'getApprovedSubjects'
    ])
  }
}
</script>

<style lang="scss">
.disciplina{
    display: grid;
    grid-template-columns: 100%;
    grid-template-rows: 100%;

    margin: 0.5em 1em;
}

.disciplina_status {
  grid-row: 1 / 2;
  grid-column: 1 / 2;

  display: flex;
  flex-flow: row nowrap;
  justify-content: center;
  align-items: center;

  color: $light-color;
  width: 5rem;
  height: 5rem;
  border-radius: 100%;
  font-size: 2rem;

  user-select: none;
  cursor: pointer;
}

.disciplina_under_button {
  grid-row: 1 / 2;
  grid-column: 1 / 2;

  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;

  background-color: $light-color;
  color: $dark-color;
  border-style: solid;

  font-size: 13px;

  border-width: 0;
  border-radius: 100%;

  width: 1.5rem;
  height: 1.5rem;

  user-select: none;
  cursor: pointer;

  box-shadow: 0.25em 0.25em 0.5em rgba(0, 0, 0, 0.1);
}

.disciplina_info {
  justify-self: end;
  align-self: start;
}

.disciplina_counter {
  justify-self: end;
  align-self: end;
}

.disciplina_code {
    grid-row: 2 / 3;
    grid-column: 1 / 2;

    margin-top: 0.5em;
    justify-self: center;
}
</style>
